
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Struts2 和 Spring MVC 孰优孰劣 / iVAN</title>

    <meta name="description" content="Struts2 和 Spring MVC 孰优孰劣 最近我在将APDPlat升级到Java8,由于之前有很多的同学希望我把APDPlat的struts2替换为spring mvc,所以我就决定试试看. 本次我把APDPlat的struts2改造为spring mvc的目标是:99.99%不改动JS.HTML.JSP等前端代码,只改JAVA代码!所以大家要先理解我的目标,然后再来看我的做法. 本文我们看两个转换前后的例子: 1.下拉列表服务,此类比较简单,只涉及一个方法store: 使用struts2: @Scope(&quot;prototype ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Struts2 和 Spring MVC 孰优孰劣</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>最近我在将APDPlat升级到Java8，由于之前有很多的同学希望我把APDPlat的struts2替换为spring mvc，所以我就决定试试看。</p>
<p>本次我把APDPlat的struts2改造为spring mvc的目标是：99.99%不改动JS、HTML、JSP等前端代码，只改JAVA代码！所以大家要先理解我的目标，然后再来看我的做法。</p>
<p>本文我们看两个转换前后的例子：</p>
<p>1、下拉列表服务，此类比较简单，只涉及一个方法store：</p>
<p>使用struts2：</p>
<pre><code>@Scope("prototype")
@Controller
@Namespace("/dictionary")
public class DicAction extends ExtJSSimpleAction&lt;Dic&gt; {
    @Resource
    private DicService dicService;
    private String dic;
    private String tree;
    private boolean justCode;

    /**
     *
     * 此类用来提供下拉列表服务,主要有两种下列类型：
     * 1、普通下拉选项
     * 2、树形下拉选项
     * @return 不需要返回值，直接给客户端写数据
     *
     */
    public String store(){
        Dic dictionary=dicService.getDic(dic);
        if(dictionary==null){
            LOG.info("没有找到数据词典 "+dic);
            return null;
        }
        if("true".equals(tree)){
            String json = dicService.toStoreJson(dictionary);
            Struts2Utils.renderJson(json);
        }else{
            List&lt;Map&lt;String,String&gt;&gt; data=new ArrayList&lt;&gt;();
            for(DicItem item : dictionary.getDicItems()){
                Map&lt;String,String&gt; map=new HashMap&lt;&gt;();
                if(justCode){
                    map.put("value", item.getCode());
                }else{
                    map.put("value", item.getId().toString());
                }
                map.put("text", item.getName());
                data.add(map);
            }
            Struts2Utils.renderJson(data);
        }
        return null;
    }

    publ
i```
c void setJustCode(boolean justCode) {
        this.justCode = justCode;
    }

    public void setTree(String tree) {
        this.tree = tree;
    }

    public void setDic(String dic) {
        this.dic = dic;
    }
}
使用spring mvc：

```javascript
@Scope("prototype")
@Controller
@RequestMapping("/dictionary")
public class DicAction extends ExtJSSimpleAction&lt;Dic&gt; {
    @Resource
    private DicService dicService;

    /**
     *
     * 此类用来提供下拉列表服务,主要有两种下拉类型：
     * 1、普通下拉选项
     * 2、树形下拉选项
     * @param dic
     * @param tree
     * @param justCode
     * @return 返回值直接给客户端
     */
    @ResponseBody
    @RequestMapping("/dic!store.action")
    public String store(@RequestParam(required=false) String dic,
                        @RequestParam(required=false) String tree,
                        @RequestParam(required=false) String justCode){
        Dic dictionary=dicService.getDic(dic);
        if(dictionary==null){
            LOG.info("没有找到数据词典 "+dic);
            return "";
        }
        if("true".equals(tree)){
            String json = dicService.toStoreJson(dictionary);
            return json;
        }else{
            List&lt;Map&lt;String,String&gt;&gt; data=new ArrayList&lt;&gt;();
            dictionary.getDicItems().forEach(item -&gt; {
                Map&lt;String,String&gt; itemMap=new HashMap&lt;&gt;();
                if("true".equals(justCode)){
                    itemMap.put("value", item.getCode());
                }else{
                    itemMap.put("value", item.getId().toString());
                }
                itemMap.put("text", item.getName());
                data.add(itemMap);
            });
            String json = JSONArray.fromObject(data).toString();
            return json;
        }
    }
}

</code></pre>
<p>从上面我们可以看到，struts2和spring mvc的区别非常明显，struts2使用原型，spring mvc使用单例。</p>
<p>单例一定比原型快吗？创建一个对象的开销可以忽略吗？这个问题需要在自己的场景中考虑，不过大多时候我们是可以忽略的。</p>
<p>APDPlat之前使用struts2，每一个请求都会对应一个全新的Action，所以请求的参数就可以作为Action的字段来自动注入，言下之意就是Action中的所有方法都可以共用字段，而现在换成spring mvc了，不同的方法需要各自获取请求中的参数。</p>
<p>对比以上代码，我个人还是认为spring mvc的方式更好一些，对于Action（spring mvc叫Controller）来说，单例、无状态是比较理想的。</p>
<p>2、数据字典服务，此类比较复杂，涉及的方法有create、delete、updatePart、retrieve、query、store：</p>
<p>使用struts2：</p>
<pre><code>@Scope("prototype")
@Controller
@Namespace("/dictionary")
public class DicItemAction extends ExtJSSimpleAction&lt;DicItem&gt; {
    @Resource
    private DicService dicService;
    private String node;

    /**
     * 返回数据字典目录树
     * @return
     */
    public String store() {
        if (node == null) {
            return null;
        }
        Dic dic=null;
        if(node.trim().startsWith("root")){
            dic = dicService.getRootDic();
        }else{
            int id=Integer.parseInt(node);
            dic = dicService.getDic(id);
        }

        if (dic != null) {
            String json = dicService.toJson(dic);
            Struts2Utils.renderJson(json);
        }
        return null;
    }

    public void setNode(String node) {
        this.node = node;
    }
}

</code></pre>
<p>使用spring mvc：</p>
<pre><code>@Scope("prototype")
@Controller
@RequestMapping("/dictionary")
public class DicItemAction extends ExtJSSimpleAction&lt;DicItem&gt; {
    @Resource
    private DicService dicService;

    /**
     * 返回数据字典目录树
     * @param node
     * @return
     */
    @ResponseBody
    @RequestMapping("/dic-item!store.action")
    public String store(@RequestParam(required=false) String node) {
        if (node == null) {
            return "[]";
        }
        Dic dic=null;
        if(node.trim().startsWith("root")){
            dic = dicService.getRootDic();
        }else{
            int id=Integer.parseInt(node);
            dic = dicService.getDic(id);
        }

        if (dic != null) {
            String json = dicService.toJson(dic);
            return json;
        }
        return "[]";
    }
    @ResponseBody
    @RequestMapping("/dic-item!query.action")
    public String query(@RequestParam(required=false) Integer start,
                        @RequestParam(required=false) Integer limit,
                        @RequestParam(required=false) String propertyCriteria,
                        @RequestParam(required=false) String orderCriteria,
                        @RequestParam(required=false) String queryString,
                        @RequestParam(required=false) String search){
        super.setStart(start);
        super.setLimit(limit);
        super.setPropertyCriteria(propertyCriteria);
        super.setOrderCriteria(orderCriteria);
        super.setQueryString(queryString);
        super.setSearch("true".equals(search));
        return super.query();
    }
    @ResponseBody
    @RequestMapping("/dic-item!retrieve.action")
    public String retrieve(@ModelAttribute DicItem model) {
        super.model = model;
        return super.retrieve();
    }
    @ResponseBody
    @RequestMapping("/dic-item!delete.action")
    public String delete(@RequestParam String ids) {
        super.setIds(ids);
        return super.delete();
    }
    @ResponseBody
    @RequestMapping("/dic-item!create.action")
    public String create(@ModelAttribute DicItem model) {
        super.model = model;
        return super.create();
    }
    @ResponseBody
    @RequestMapping("/dic-item!updatePart.action")
    public String updatePart(@ModelAttribute DicItem model) {
        super.model = model;
        return super.updatePart();
    }
}

</code></pre>
<p>从上面可以看到，从struts2转换为spring mvc之后，代码一下子就增加了，父类的create、delete、updatePart、retrieve、query这5个方法对于spring mvc就无效了，而且模型注入的方式也不起作用了，下面我们要解决这两个问题。</p>
<p>要解决第一个问题，我们首先要改变struts2的URL调用方式，在struts2中，我们是这么调用Action的方法的，!后面是Action的方法名称：</p>
<pre><code>http://localhost:8080/APDPlat_Web-2.6/dictionary/dic-item!query.action

</code></pre>
<p>如果我们不改变调用方式，上面刚说的那5个方法就无法抽象到父类中了，改变方式也挺简单，只需要把!改成/就可以了，在父类中增加如下代码并在前端JS中将!改成/：</p>
<pre><code>@ResponseBody
@RequestMapping("query.action")
public String query(@RequestParam(required=false) Integer start,
                    @RequestParam(required=false) Integer limit,
                    @RequestParam(required=false) String propertyCriteria,
                    @RequestParam(required=false) String orderCriteria,
                    @RequestParam(required=false) String queryString,
                    @RequestParam(required=false) String search){
    super.setStart(start);
    super.setLimit(limit);
    super.setPropertyCriteria(propertyCriteria);
    super.setOrderCriteria(orderCriteria);
    super.setQueryString(queryString);
    setSearch("true".equals(search));
    return query();
}

@ResponseBody
@RequestMapping("retrieve.action")
public String retrieve(@ModelAttribute T model) {
    this.model = model;
    return retrieve();
}

@ResponseBody
@RequestMapping("delete.action")
public String delete(@RequestParam String ids) {
    super.setIds(ids);
    return delete();
}

@ResponseBody
@RequestMapping("create.action")
public String create(@ModelAttribute T model) {
    this.model = model;
    return create();
}

@ResponseBody
@RequestMapping("updatePart.action")
public String updatePart(@ModelAttribute T model) {
    this.model = model;
    return updatePart();
}

</code></pre>
<p>关于第二个问题，在struts2中，注入Action的参数，要使用model.id这样的方式，model是Action的一个字段，而在spring mvc中，这样是不行的，需要做一个转换，在父类中增加如下代码以使spring mvc能适应struts2参数注入方式：</p>
<pre><code>/**
 * 前端向后端传递模型参数的时候都有model.前缀
 * @param binder
 */
@InitBinder
public void initBinder(WebDataBinder binder) {
    binder.setFieldDefaultPrefix("model.");
}

</code></pre>
<p>经过上面的改进，数据字典服务 使用spring mvc的代码升级为：</p>
<pre><code>@Scope("prototype")
@Controller
@RequestMapping("/dictionary/dic-item/")
public class DicItemAction extends ExtJSSimpleAction&lt;DicItem&gt; {
    @Resource
    private DicService dicService;

    /**
     * 返回数据字典目录树
     * @param node
     * @return
     */
    @ResponseBody
    @RequestMapping("store.action")
    public String store(@RequestParam(required=false) String node) {
        if (node == null) {
            return "[]";
        }
        Dic dic=null;
        if(node.trim().startsWith("root")){
            dic = dicService.getRootDic();
        }else{
            int id=Integer.parseInt(node);
            dic = dicService.getDic(id);
        }

        if (dic != null) {
            String json = dicService.toJson(dic);
            return json;
        }
        return "[]";
    }
}

</code></pre>
<p>文章转载自 开源中国社区 [<a href="http://www.oschina.net" rel="external nofollow noreferrer">http://www.oschina.net</a>]</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 08:39:41</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/create/" title="Create">Create</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/json/" title="json">json</a>, <a href="https://www.iamivan.net/tag/node/" title="node">node</a>, <a href="https://www.iamivan.net/tag/javascript/" title="javascript">javascript</a>, <a href="https://www.iamivan.net/tag/prototype/" title="prototype">prototype</a>, <a href="https://www.iamivan.net/tag/mvc/" title="mvc">mvc</a>, <a href="https://www.iamivan.net/tag/spring/" title="spring">spring</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Struts2 和 Spring MVC 孰优孰劣的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdEP6Az.html" rel="bookmark">二代 Nexus 7 与 iPad mini孰优孰劣</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://www.aliyun.com/zixun/aggregation/624.html&quot;&gt;谷歌昨日发布了新一代 Nexus 7,让我们看看它与同为小平板的 iPad mini 相比孰优孰劣. 大小 新版 Nexus 7 比 iPad mini 窄 16%,比 iPad mini 厚 21%. 重量 二代 Nexus 7 比 iPad mini 轻 6%. 制造工艺 塑料 VS 铝合金 显示屏 二代 Nexus 7 比 iPad mini 每英寸像素点多了 162 个,显示精度远高			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mx57oOp.html" rel="bookmark">解析：云存储和实体存储 孰优孰略？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着国内几大传统网盘公司,新浪微云.115云盘.金山云盘等或破产倒闭或有偿使用,曾经蓬勃发展的免费云存储行业,遇到了行业性的破产危机. 虽然市场上依旧活跃着诸如百度云盘.360免费云盘等产品,但是相比较于先前的免费极速的绝佳体验,百度云等云盘的阉割和限速也使得存活下来的云盘产品的前景,光辉不再. 尤其是,国内用户普遍没有付费使用网络服务的消费意识,这让有着巨大运营成本,却没有多种有效的盈利模式的网盘企业,承担着相当的运营风险和压力,一着不慎,就有可能步前辈之后尘. 云存储和实体存储 孰优孰略?			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7Yx4XM.html" rel="bookmark">一决高下，分布式流处理框架孰优孰劣</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文PPT来自技术专家毛玮于10月16日在2016年杭州云栖大会上发表的&lt;分布式流处理框架--功能对比和性能评估&gt;. 目前,分布式流处理框架数量不少,各有特色,究竟哪个性能更好.哪个效率更高.哪个更适合我呢?一般来说,当选择不同的流处理系统时,我们往往需要关注以下六大方面:1.运行时和编程模型2.函数式原语3.状态管理 4.消息传输保障 5.容错 6.性能. 其中,运行时模型主要包括原生的流处理和微批处理.流处理意味着所有输入的记录一旦到达即会一个接着一个进行处理,微批处理则把输入的数据按照某			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLmePLz.html" rel="bookmark">论社区搜索广告与普通搜索广告孰优孰劣</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 当开始这个话题讨论的时候,我在思考了很久,要以怎样的方式开始这篇文章.最终我决定以一种对话的形式来开始这篇文章.这里大体介绍下社区搜索(例如Facebook,sns等网站中嵌入的搜索形式);普通搜索就是我们常见的谷歌,百度等这些搜索引擎. 普通搜索广告说自己的优势就是当你去搜索某个关键词,搜索引擎就会返回一个跟关键词相关的搜索广告.提供的广告			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqRQPOp.html" rel="bookmark">基于移动设备的机器学习，本地与云端孰优孰劣？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				雷锋网按:如果您觉得,是时候给自己的手机应用添加一些热门的机器学习或深度学习算法.....这是个好想法!但您会怎么选择?致力于提供算法服务及小白科普的咨询师 Matthijs Hollemans 近期在博客上分享了他的一些心得体会,雷锋网独家编译,未经许可不得转载. 绝大多数机器学习实现方法的步骤不外乎如下三点: 采集数据 利用采集的数据来训练一个模型 使用该模型进行预测 假设想做一个&quot;名人匹配 (celebrity match) &quot;的应用程序,告诉用户他们和哪位名人最相似.首先收集众			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAEYAnM.html" rel="bookmark">Spark和Hadoop，孰优孰劣</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spark已经取代Hadoop成为最活跃的开源大数据项目,但是,在选择大数据框架时,企业不能因此就厚此薄彼 近日,著名大数据专家Bernard Marr在一篇文章中分析了Spark和 Hadoop 的异同   Hadoop和Spark均是大数据框架,都提供了一些执行常见大数据任务的工具,但确切地说,它们所执行的任务并不相同,彼此也并不排斥 虽然在特定的情况下,Spark据称要比Hadoop快100倍,但它本身没有一个分布式存储系统 而分布式存储是如今许多大数据项目的基础,它可以将 PB 级的数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bK0Xk5M.html" rel="bookmark">孰优孰劣 &mdash; 开源 vs&period; 闭源</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开源操作系统和闭源操作系统之间有诸多不同.这里我们仅寥书几笔. 开源是什么?自由! 这是用户需要知道的最重要的一点.无论我是否打算修改代码,其他人出于善意的修改都不应受到限制.且如果用户喜欢,他们可以分享这个软件.使用开源软件,这些都是可能的. 闭源操作系统的许可条款很是吓人.但真的所有人都会看吗?不,许多用户只是点了一下'Accept' 而已. 价格 几乎所有的开源操纵系统是免费的.仅有自愿性质的捐款.且只需有个一个 CD/DVD 或 USB 就能将系统安装到所有你想要安装的电脑上. 闭源操作			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmRQyjz.html" rel="bookmark">四大云计算平台对比 孰优孰劣见分晓？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				软件产品开发公司Altoros Systems的IT基础设施设计师Vadim Truksha在美国&lt;网络世界&gt;上发表一篇文章,详细对比了CloudStack.Eucalyptus.vCloud Director和OpenStack等四个云平台.文章全文如下: 考虑到云计算有极大的潜力提高效率,显著节省成本,实现可升级的基础设施和高性能以及安全的数据存储,云计算仍然是目前IT领域最热门的话题之一. 然而,选择合适的云平台是很困难的.这些云平台都有支持意见和反对意见.因此,Truksha说,当一个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPZ3nrb.html" rel="bookmark">孰优孰劣，新渴望8系对战魅族MX3（图）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着新渴望8系易迅网首轮抢购的结束,这款手机的人气也正以&quot;野蛮增长&quot;的趋势继续攀升.凭借着首销10分钟就售出50000台的&quot;话题优势&quot;,新渴望8系成功上位今年最受关注的新机型之一.作为今年颇受关注的 一款中端新机,新渴望8系难免会被拿来与以往的人气单品作比对,而说到中端手机市场的&quot;旧宠&quot;,大家 首先想到的应该就是去年9月份上市的http://www.aliyun.com/zixun/aggregation/2229.html&quot;&gt;魅			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7kvqz.html" rel="bookmark" class="title">C&num;输入年份，判断闰年平年</a>
					<div>
						private void btnJudge_Click(object sender, EventArgs e) { uint uiYear; if (uint.TryParse(txtYear.Tex ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5OkWb.html" rel="bookmark" class="title">ajax入门指南（三）</a>
					<div>
						ajax入门指南,相信对ajax初学者会有所帮助. AJAX的主流框架:       浏览器端框架:       一．Prototype系列:         1.Prototype:http://p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqDxab.html" rel="bookmark" class="title">了解 XML</a>
					<div>
						xml 摘要:了解可扩展标记语言 (XML) 如何帮助我们实现通用的数据访问.XML 是一种基于 Unicode 的纯文本元语言,即一种用于定义标记语言的语言.它不依赖于任何编程语言.操作系统或软件供 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeQAwz.html" rel="bookmark" class="title">windows 2000活动目录之结构篇</a>
					<div>
						在上一篇对活动目录有个基本了解之后下面我就来接触一下活动目录实质上的一面--活动目录的结构.上篇我们讲到活动目录是包括两方面:目录和目录相关的服务.目录是存储各种对象的一个物理上的容器,与我们平常所说 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz4QxYb.html" rel="bookmark" class="title">C语言实现修改文本文件中的特定行</a>
					<div>
						最近由于项目需要实现修改文件的功能,所以,博主认真查阅了一些资料,但是,很遗憾,并没有太多的 收获. 好的,首先我先叙述下功能要求: 其实很简单,就是Shell中sed命令的C语言实现,实 现定位到所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm77ABb.html" rel="bookmark" class="title">Javascript图像处理：虚拟边缘</a>
					<div>
						前言 上一篇文章,我们来给矩阵添加一些常用方法,这篇文章将讲解图像的虚拟边缘. 虚拟边缘 虚拟边缘就是按照一定映射关系,给图像添加边缘. 那么虚拟边缘有什么用呢?比如可以很容易做一个倒影的效果 :					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1Rd2xp.html" rel="bookmark" class="title">WCF分布式开发常见错误&lpar;28&rpar;</a>
					<div>
						WCF分布式开发常见错误(28):The requested upgrade is not supported by... 今天在调试WCF4.0 Routing 路由服务例子代码的时候,启动客户端测 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7nP4b.html" rel="bookmark" class="title">2345看图王截图保存位置在哪？</a>
					<div>
						  2345看图王截图保存位置在哪? 1.当你截图完成之后,打开2345图片管理 2345看图王 2.在我的电脑中,查找2345截图文件,点击即可找到相关截图					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDAlqXb.html" rel="bookmark" class="title">搜狗输入法不认识的字怎么打？</a>
					<div>
						  搜狗输入法不认识的字怎么打?小编将在下文演示使用搜狗输入法打不认识的字步骤,当我们遇到了一个不认识的字,不知道怎么拼音,也不会使用五笔,该怎么打出来呢? 当我们遇见一个生僻字的时候.比如&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlR39Dz.html" rel="bookmark" class="title">PS CS5提高运行速度的设置方法</a>
					<div>
						[前言] Adobe Photoshop CS5 从功能上对硬件性能地利用,比老版本有了很大的改进. 但是非高配的朋友,都会抱怨使用起来还是会卡,尤其是开启软件的时候.(当然,也有高配的朋友喊卡) 其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGK39p.html" rel="bookmark" class="title">利用WPS快速计算平均分</a>
					<div>
						  学校举行演讲比赛,多位评委给选手打分,算平均分时要先去掉两个最高分和两个最低分,如何解决这一问题呢?打开WPS表格,实践一下吧! 一.录入各位选手的得分. 计算平均分-wps怎么算平均分&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZZoNb.html" rel="bookmark" class="title">仿水彩油画照片效果的PS教程</a>
					<div>
						一个特殊的电影放映机用来一次播放一帧画面,只不过这种电影不是映射在荧幕上,而是映射在艺术家的纸上.你只需要一帧一帧的来描绘出各个画面就可以了.利用这种技术得到的手绘的运动图象也会给人一种强烈的栩栩如生 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwLxrEb.html" rel="bookmark" class="title">酷盘如何邀请手机联系人使用</a>
					<div>
						  酷盘如何邀请手机联系人使用的方法如下: 酷盘iPhone平台客户端 1.软件运行中,点击下图红色方框位置的&quot;设置&quot;图标. 2.设置界面下,点击下图中红色方框处的&quot;免费 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNwQ8M.html" rel="bookmark" class="title">设置SmartArt图形文本等高字符和字符间距</a>
					<div>
						  Word2010文档中的SmartArt图形文本有时需要设置字符间距.等高字符.上标.下标和下划线等字体效果,此时可以借助&quot;字体&quot;对话框来实现,操作步骤如下所述: 第1步,打开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WaZnb.html" rel="bookmark" class="title">电脑软件故障处理顺序</a>
					<div>
						当电脑出现故障时,如果故障属于软件故障,则按照下面的处理顺序进行检修. 1.判断故障 维修故障前,首先尽可能详细地了解故障发生前后的情况,包括发生故障前正在运行哪些软件.正在使用哪些设备及故障发生后出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6gPdb.html" rel="bookmark" class="title">jQuery Makes Parsing XML Easy&lbrack;转&rsqb;</a>
					<div>
						jQuery Makes Parsing XML Easy Category: JavaScript &amp; jQuery Tags: jQuery, JavaScript, XML | Writ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5onORb.html" rel="bookmark" class="title">突然发现有人翻译了Android开发的相关开发文档，而且翻译得很好，推荐下</a>
					<div>
						突然发现有人翻译了Android开发的相关开发文档,而且翻译得很好,推荐下   http://wiki.eoeandroid.com/Android_Training http://wiki.eoea ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NQwBz.html" rel="bookmark" class="title">Facebook利用AI算法&OpenCurlyDoubleQuote;纠偏&rdquo;360度照片</a>
					<div>
						据外媒VentureBeat报道,Facebook今日向外表示,为了给用户提供更好的360度视频观看体验,其将利用AI算法来对这些内容进行调整,避免因为图片倾斜破坏呈现效果. 据悉,在今日举办的@Sc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3m9lz.html" rel="bookmark" class="title">&lbrack;翻译&rsqb; TCBlobDownload</a>
					<div>
						TCBlobDownload   TCBlobDownload uses NSOperations to download large files (typically videos, music.. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwkAlM.html" rel="bookmark" class="title">闹钟的设计原理与实现</a>
					<div>
						闹钟的设计原理与实现(一)   华中科技大学 陈学友 2012年5月18日     内容摘要 现在很多人由于需要处理各种事物,但是由于某些原因可能会忘记在某个时间段需要完成的工作和其他事情,因此需要一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVgwmb.html" rel="bookmark" class="title">工作流引擎Activiti使用总结</a>
					<div>
						1.简单介工作流引擎与Activiti 对于工作流引擎的解释请参考百度百科:工作流引擎 1.1 我与工作流引擎 在第一家公司工作的时候主要任务就是开发OA系统,当然基本都是有工作流的支持,不过当时使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGE36EM.html" rel="bookmark" class="title">Git&commat;OSC 国际化 &mdash;&mdash; 支持中英文双语显示</a>
					<div>
						Git@OSC 代码托管平台新增国际化特性,目前支持简体中文和英文两种语言显示. 国内的不少开源软件作者希望自己的产品也能同时被国外的用户所使用,但同时又希望国内的用户可以快速访问项目源码.因此很多作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRjaNb.html" rel="bookmark" class="title">姚从刚：对网络营销的观点总结</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 一.人才篇 1.网络营销核心 最珍贵的是&quot;创意&quot;;最核心的是&quot;策划&quot;;最难得的是人才,尤其是策划人才! 真正关键 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z40a5qz.html" rel="bookmark" class="title">复选框左右移动</a>
					<div>
						&lt;div class=&quot;modal fade&quot; id=&quot;configStaff&quot; tabindex=&quot;-2&quot; role=&quot;d ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7xDqp.html" rel="bookmark" class="title">阿里云免费企业邮箱申请流程</a>
					<div>
						摘要: 免费版的阿里云企业邮箱给你一个很好的体验,享受中小企业发展时期的优惠扶持.那怎么才能申请阿里云免费的企业邮箱呢??    免费版的阿里云企业邮箱给你一个很好的体验,享受中小企业发展时期的优惠扶 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZB7Kaz.html" rel="bookmark" class="title">高考考生已成不法分子觊觎&OpenCurlyDoubleQuote;肥肉&rdquo; 个人信息及财产成重点目标</a>
					<div>
						高考结束之后,迎接考生的不仅仅只有狂欢,还有网络不法分子伺机而动的&quot;魔爪&quot;.利用考生对于选择高校.填报志愿等需求,网络不法分子正通过钓鱼网站等形式,想方设法骗取考生的个人信息以及真 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3J1LAz.html" rel="bookmark" class="title">hibernate 的问题啊</a>
					<div>
						问题描述 用DetachedCriteria类 组装查询条件,咋个生成这样的sql语句了捏? 如果没没条件的话还行 ,一加上where条件查询,就会出 where y1_.... 然后就报错:列名 ' ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZGklp.html" rel="bookmark" class="title">Asp&period;net中Json数据的转化&comma;读取与应用</a>
					<div>
						  JSON (JavaScript Object Notation) 是一种轻量级的数据交换格式,易于人阅读和编写,同时也易于机器解析和生成,而且它是基于JavaScript 的. JSON采用完全 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRGxrp.html" rel="bookmark" class="title">英特尔马子雅：深度学习四大痛点与BigDL解决之道</a>
					<div>
						   [51CTO.com原创稿件]在万物智能互联时代,数以亿计的智能互联设备及其产生的数据洪流带来了产业的数字化变革.越来越多的企业希望借助机器学习与深度学习,从海量数据中获取切实可行的洞察以指导企 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M601yWz.html" rel="bookmark" class="title">socket通信怎样把端口写在一个文件中</a>
					<div>
						问题描述 socket通信,原来指定了一个端口80,现在要修改下程序,使程序变得更灵活些,用户可以设置要监听的端口.比如,把端口写在一个文件中.也就是,程序首次运行时,如果不存在配置文件,则创建一个配 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
